diff --git a/zebra/main.c b/zebra/main.c
index e38f9a85e3b1..eafc051688dc 100644
--- a/zebra/main.c
+++ b/zebra/main.c
@@ -204,6 +204,8 @@ static void sigint(void)
 	 */
 	zebra_routemap_finish();
 
+	rib_update_finish();
+
 	list_delete(&zrouter.client_list);
 
 	/* Indicate that all new dplane work has been enqueued. When that
diff --git a/zebra/rib.h b/zebra/rib.h
index 166500fa5cc7..01610631279b 100644
--- a/zebra/rib.h
+++ b/zebra/rib.h
@@ -338,6 +338,7 @@ enum rib_update_event {
 	RIB_UPDATE_OTHER,
 	RIB_UPDATE_MAX
 };
+void rib_update_finish(void);
 
 int route_entry_update_nhe(struct route_entry *re,
 			   struct nhg_hash_entry *new_nhghe);
diff --git a/zebra/zebra_rib.c b/zebra/zebra_rib.c
index b33f6ad384c6..5e50d720a61f 100644
--- a/zebra/zebra_rib.c
+++ b/zebra/zebra_rib.c
@@ -4393,6 +4393,22 @@ static void rib_update_handler(struct thread *thread)
  */
 static struct thread *t_rib_update_threads[RIB_UPDATE_MAX];
 
+void rib_update_finish(void)
+{
+	int i;
+
+	for (i = RIB_UPDATE_KERNEL; i < RIB_UPDATE_MAX; i++) {
+		if (thread_is_scheduled(t_rib_update_threads[i])) {
+			struct rib_update_ctx *ctx;
+
+			ctx = THREAD_ARG(t_rib_update_threads[i]);
+
+			rib_update_ctx_fini(&ctx);
+			THREAD_OFF(t_rib_update_threads[i]);
+		}
+	}
+}
+
 /* Schedule a RIB update event for all vrfs */
 void rib_update(enum rib_update_event event)
 {
@@ -4401,6 +4417,9 @@ void rib_update(enum rib_update_event event)
 	if (thread_is_scheduled(t_rib_update_threads[event]))
 		return;
 
+	if (zebra_router_in_shutdown())
+		return;
+
 	ctx = rib_update_ctx_init(0, event);
 
 	thread_add_event(zrouter.master, rib_update_handler, ctx, 0,
